<!DOCTYPE html>
<html>
  <script
    type="text/javascript"
    src="//www.gstatic.com/cast/sdk/libs/receiver/2.0.0/cast_receiver.js"
  ></script>
  <script src="/icecast-metadata-js/icecast-metadata-player-1.11.3.min.js"></script>
  <link
    href="https://fonts.googleapis.com/css?family=Montserrat&display=swap"
    rel="stylesheet"
  />

  <script>
    // helper functions
    const formatTime = (seconds = 0) =>
      new Date(seconds * 1000).toISOString().substr(14, 8);

    const formatMetadata = (json) =>
      JSON.stringify(json, null, 1)
        .replace(/\{\n|\n\}/g, "")
        .replace(/\n/g, "<br>");
  </script>

  <head>
    <title>Icecast Metadata JS Demo</title>

    <style type="text/css">
      body {
        overflow: hidden;
        background: #000;
        color: cyan;
        font-family: Montserrat;
        margin: 0;
      }
      canvas {
        position: absolute;
        z-index: -1;
        margin: 0;
        padding: 0;
      }
      .container {
        padding: 8px;
      }
      .row {
        display: flex;
        flex-direction: row;
      }
      .codec-information {
        margin: 1px 0 0 15px;
      }
      .metadata-info {
        width: auto;
      }
      pre {
        margin: 0px;
      }
      .metadata-table {
        border-spacing: 10px 0;
      }
      .metadata-time {
        text-align: right;
      }
      .metadata,
      .metadata-time {
        font-size: 12px;
        font-family: monospace;
      }
      .metadata-header {
        text-align: left;
        font-size: 14px;
      }
    </style>
  </head>

  <body>
    <canvas></canvas>
    <div class="container">
      <div class="row">
        <div class="metadata-info">
          <h3>Metadata</h3>
          <table class="metadata-table">
            <tbody>
              <tr>
                <th class="metadata-header">Current Time</th>
                <th class="metadata-header">Now Playing</th>
              </tr>
              <tr>
                <td class="metadata-time"><div id="currentTime"></div></td>
                <td class="metadata"><div id="metadata"></div></td>
              </tr>
            </tbody>
          </table>
          <table class="metadata-table">
            <tbody id="metadataQueue"></tbody>
          </table>
        </div>
        <div class="codec-information">
          <h3>Codec Updates</h3>
          <div
            style="font-family: monospace; white-space: normal; font-size: 10px"
            id="audioInfo"
          ></div>
        </div>
      </div>
    </div>
  </body>
  <script>
    // IcecastMetadataPlayer
    const metadataEl = document.getElementById("metadata");
    const metadataQueueEl = document.getElementById("metadataQueue");
    const currentTimeEl = document.getElementById("currentTime");
    const audioInfoEl = document.getElementById("audioInfo");

    currentTimeEl.attachShadow({ mode: "open" });
    audioInfoEl.attachShadow({ mode: "open" });

    let icecastMetadataPlayer, timer, currentTime, stationData;

    const onMetadata = (metadata) => {
      metadataEl.innerHTML = formatMetadata(metadata);

      onMetadataEnqueue();
    };

    const onCodecUpdate = (audioCodecData, duration) => {
      audioInfoEl.shadowRoot.innerHTML = `<div style="margin: 5px 0;">Last Updated: ${formatTime(
        duration
      )}</div><table style="border-spacing: 10px 0; margin-top: 5px"><tbody>${Object.entries(
        audioCodecData
      )
        .sort(([a], [b]) => a.localeCompare(b))
        .reduce(
          (acc, [key, value]) =>
            acc + `<tr><td>${key}</td><td>${value}</td></tr>`,
          ""
        )}</tbody></table>`;
    };

    const onMetadataEnqueue = () => {
      metadataQueueEl.innerHTML = icecastMetadataPlayer.metadataQueue.reduce(
        (acc, { metadata, timestampOffset }) =>
          acc +
          `<tr><td class="metadata-time">${formatTime(timestampOffset)}</td>` +
          `<td class="metadata">${formatMetadata(metadata)}</td></tr>`,
        `<th class="metadata-header">Update Time</th>` +
          `<th class="metadata-header">Up Next</th>`
      );
    };

    const onStreamStart = () => {
      metadataEl.innerHTML = "";
    };

    const onPlay = () => {
      currentTime = 0;
      clearInterval(timer);
      timer = setInterval(() => {
        currentTime += 1;
        currentTimeEl.shadowRoot.innerHTML = formatTime(currentTime.toFixed(2));
      }, 1000);
    };

    const onStop = () => {
      clearInterval(timer);
    };

    const onError = (message) => {
      metadataEl.innerHTML = message;
    };

    const changeStation = (data) => {
      stationData = data;
    };

    const play = () => {
      if (icecastMetadataPlayer) icecastMetadataPlayer.stop();

      clearInterval(timer);
      currentTimeEl.shadowRoot.innerHTML = "";
      audioInfoEl.shadowRoot.innerHTML = "";
      metadataEl.innerHTML = "Loading...";
      metadataQueueEl.innerHTML = "";
      currentTimeEl.innerHTML = formatTime(0);

      icecastMetadataPlayer = new IcecastMetadataPlayer(stationData.endpoint, {
        metadataTypes: stationData.metadataTypes,
        icyDetectionTimeout: stationData.icyDetectionTimeout,
        icyCharacterEncoding: stationData.icyCharacterEncoding,
        bufferLength: stationData.bufferLength,
        retryTimeout: stationData.retryTimeout,
        retryDelayRate: stationData.retryDelayRate,
        retryDelayMin: stationData.retryDelayMin,
        retryDelayMax: stationData.retryDelayMax,
        playbackMethod: stationData.playbackMethod,
        enableLogging: true,
        onStreamStart,
        onPlay,
        onStop,
        onMetadata,
        onMetadataEnqueue,
        onCodecUpdate: stationData.enableCodecUpdate && onCodecUpdate,
        onError,
      });

      icecastMetadataPlayer.play();
    };

    const stop = () => {
      icecastMetadataPlayer.stop();
    };
  </script>
  <script>
    window.castReceiverManager =
      cast.receiver.CastReceiverManager.getInstance();

    castReceiverManager.onReady = function (event) {
      window.castReceiverManager.setApplicationState(
        "Icecast Metadata JS Demo"
      );
    };

    const namespace = "urn:x-cast:icecast-metadata-js-demo";
    window.messageBus = window.castReceiverManager.getCastMessageBus(namespace);

    window.messageBus.onMessage = (e) => {
      const { command, ...payload } = JSON.parse(e.data);

      if (command === "play") play();
      if (command === "stop") stop();
      if (command === "change station") changeStation(payload);
    };

    window.castReceiverManager.start({
      statusText: "Icecast Metadata JS Demo starting...",
    });
  </script>

  <script>
    const NUM_CONFETTI = 30;
    const COLORS = [
      [85, 71, 106],
      [174, 61, 99],
      [219, 56, 83],
      [244, 92, 68],
      [248, 182, 70],
    ];
    const PI_2 = 2 * Math.PI;

    const canvas = document.querySelector("canvas");
    const context = canvas.getContext("2d", { alpha: false });

    let screenWidth = 0,
      screenHeight = 0;

    const resizeWindow = () => {
      screenWidth = canvas.width = window.innerWidth;
      screenHeight = canvas.height = window.innerHeight;
    };

    window.addEventListener("resize", resizeWindow, false);

    const range = (a, b) => (b - a) * Math.random() + a;

    const drawCircle = (x, y, r, style) => {
      const circle = new Path2D();
      circle.arc(x, y, r, 0, PI_2);
      context.fillStyle = style;
      context.fill(circle);
    };

    class Confetti {
      constructor() {
        this.style = COLORS[~~range(0, 5)];
        this.rgb = `rgba(${this.style[0]},${this.style[1]},${this.style[2]}`;
        this.focalLength = 0.5;
        this.maxOpacity = 0.5;
        this.replace();
      }

      replace() {
        this.radius = range(10, 100);
        this.opacity = 0;
        this.fadeSpeed = 0.01; //0.0005 * range(1, 3);
        this.xPos = range(-this.radius, screenWidth + this.radius);
        this.yPos = range(-this.radius, screenHeight + this.radius);
        this.xPosMin = -this.radius;
        this.yPosMin = -this.radius;
        this.xPosMax = screenWidth + this.radius;
        this.yPosMax = screenHeight + this.radius;
        this.xVelocity = range(-0.4, 0.4); //range(0, 2);
        this.yVelocity = range(-0.4, 0.4); //this.focalLength * this.radius + range(-1, 1);
      }

      draw() {
        this.xPos += this.xVelocity;
        this.yPos += this.yVelocity;

        // fade in
        this.opacity += this.fadeSpeed;
        // fade out
        if (this.opacity > this.maxOpacity) {
          this.opacity = this.maxOpacity;
          //this.fadeSpeed *= -1;
          this.fadeSpeed = 0;
        }
        if (
          this.opacity < 0 ||
          this.yPos < this.yPosMin ||
          this.xPos < this.xPosMin ||
          this.yPos > this.yPosMax ||
          this.xPos > this.xPosMax
        ) {
          this.replace();
        }
        drawCircle(
          this.xPos,
          this.yPos,
          this.radius,
          `${this.rgb},${this.opacity})`
        );
      }
    }

    const step = () => {
      requestAnimationFrame(step);
      context.fillStyle = "black";
      context.fillRect(0, 0, screenWidth, screenHeight);
      for (let i = 0; i < confetti.length; i++) confetti[i].draw();
    };

    resizeWindow();

    confetti = [];
    for (let i = 0; i < NUM_CONFETTI; i++) confetti.push(new Confetti());

    requestAnimationFrame(step);
  </script>
</html>
